#include<stdio.h>
#include<signal.h>
#include<stdlib.h>
#include<unistd.h>

void child(int s) {
  int status;

  while (waitpid(-1,&status,WNOHANG) > 0);

}


int main(int argc, char *argv[]) {
  struct sigaction action;
  int pid;
  int s;
  int fd[2];

  action.sa_handler = child;
  action.sa_flags = SA_RESTART;

  sigaction(SIGCHLD,&action,NULL);

  if (pipe(fd) < 0) {
    fprintf(stderr,"Error al crear el pipe\n");
    exit(-1);
  }

  
  pid = fork();

  if (pid < 0) {
    fprintf(stderr,"Error al crear el proceso\n");
    exit(-1);
  }

  if (pid > 0) {
    printf("Soy tu padre\n");
    
    close(1);
    close(fd[0]);
    
    dup(fd[1]);
    close(fd[1]);

    execl("/bin/ls","ls","-l","/usr/bin",NULL);
    exit(0);

  } else {
    // printf("Nooooo\n");

    close(0);
    close(fd[1]);
    
    dup(fd[0]);
    close(fd[0]);
    
    execl("/bin/more","more",NULL);
    exit(0);    
  }
  

}
